//
//  ImageDownloadOperation.swift
//  Concurrency
//
//  Created by Valery Bashkatov on 07.02.16.
//  Copyright © 2016 Valery Bashkatov. All rights reserved.
//

import UIKit

class ImageDownloadOperation: ImageOperation {
    // MARK: - Properties
    private var picture: Picture!
    
    lazy var imageDownloadTask: NSURLSessionDataTask = {
        return NSURLSession.sharedSession().dataTaskWithURL(self.picture.url,
            completionHandler:
            {
                (data: NSData?,
                response: NSURLResponse?,
                error: NSError?) -> Void in
                if error == nil {
                    self.picture.originalImage = UIImage(data: data!)!
                    self.executing = false
                    self.finished = true
                } else {
                    print(error)
                    self.executing = false
                    self.finished = true
                    self.cancel()
                }
        })
    } ()
    
    // MARK: - Initialization
    init(picture: Picture) {
        super.init()
        self.picture = picture
    }
    
    override func start() {
        executing = true
        
        // If operation is cancelled, stop process
        guard !cancelled else {
            executing = false
            finished = true
            return
        }
        
        imageDownloadTask.resume()
    }
}
