//
//  ImageOperation.swift
//  Concurrency
//
//  Created by Valery Bashkatov on 07.02.16.
//  Copyright © 2016 Valery Bashkatov. All rights reserved.
//

import Foundation

// Base image operations class
class ImageOperation: NSOperation {
    // MARK: - Properties
    // Private executing and finished properties with KVO notifications
    private var isExecuting = false {
        willSet {
            willChangeValueForKey("isExecuting")
        }
        didSet {
            didChangeValueForKey("isExecuting")
        }
    }
    
    private var isFinished = false {
        willSet {
            willChangeValueForKey("isFinished")
        }
        didSet {
            didChangeValueForKey("isFinished")
        }
    }
    
    override var executing: Bool {
        get {
            return isExecuting
        }
        set {
            isExecuting = newValue
        }
    }

    override var finished: Bool {
        get {
            return isFinished
        }
        set {
            isFinished = newValue
        }
    }
}